<!--#include virtual="/.narodsys/metrika_counter.html"-->
<i style="background:url(//www.tns-counter.ru/V13a****yandex_ru/ru/CP1251/tmsec=narod_total/0)"></i>
<!--#include virtual="/.narodsys/direct.html"-->
/*****************************************************************************
**
** program_nx3_riveting_machin_IPAC_25_november_2005.c
**
** Description:
**     Contains Unigraphics entry points for the application.
**
**	  25  2005 
**	28  2005  
**	29  2005  
**	30  2005  
**		       
**		    
**		
*****************************************************************************/

/* Include files */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>




#include <uf.h>
#include <uf_ui.h>
#include <uf_obj.h>
#include <uf_object_types.h>
#include <uf_disp.h>
#include <uf_assem.h>
#include <uf_csys.h>
#include <uf_vec.h>


#define UF_CALL(X) (report_error( __FILE__, __LINE__, #X, (X)))


static int report_error( char *file, int line, char *call, int irc)
{
    if (irc)
    {
        char err[133],
             msg[133];

        sprintf(msg, "*** ERROR code %d at line %d in %s:\n+++ ",
            irc, line, file);
        UF_get_fail_message(irc, err);

        UF_print_syslog(msg, FALSE);
        UF_print_syslog(err, FALSE);
        UF_print_syslog("\n", FALSE);
        UF_print_syslog(call, FALSE);
        UF_print_syslog(";\n", FALSE);

        if (!UF_UI_open_listing_window())
        {
            UF_UI_write_listing_window(msg);
            UF_UI_write_listing_window(err);
            UF_UI_write_listing_window("\n");
            UF_UI_write_listing_window(call);
            UF_UI_write_listing_window(";\n");
        }
    }

    return(irc);
}

int rivet_init_proc(UF_UI_selection_p_t select, void* user_data)
{
	int	ret_code;
	int	num_triples=1;
	UF_UI_mask_t	mask_triples[]={UF_component_type,0,0};

	ret_code=UF_UI_set_sel_mask
		(select,UF_UI_SEL_MASK_CLEAR_AND_ENABLE_SPECIFIC,num_triples,mask_triples);
	if(ret_code==0)
		return UF_UI_SEL_SUCCESS;
	else
		return UF_UI_SEL_FAILURE;
}


static void do_it(void)
{

	// 
	FILE*	
		fpdf;

	
	// Path Info Line

	char
		User_defind_path_name[300]	=	{"A0561"};
	int	
		NumberOfPointsInPath	=	100;
	int
		rout_number=0;
	int
			count;
	tag_p_t
			object;





	fpdf=fopen("D:\\ipac.fpdf","w");



	{
		// Head Line
		char*
			AssemblyName		=	"T7920561";
		char*
			AreaName			=	"A";
		char*
			MachineName			=	"IPAC";
		char*
			DateofProgramming	=	"25-11-2005";

		// uc1613     

		

		fprintf(fpdf,"$$HEAD, %s, %s, %s, %s\n",
			AssemblyName,AreaName,MachineName,DateofProgramming); 

	}

//   -------------------------------------
label_uc1613:
	{

		// uc1613

		char*
			cp1="  ";
		char
			cp2[2][16]={"path_name","number_of_point"};
		int
			ip3=2;
		int
			ia4[2]={0,1};
		double
			ra5[2]={0.0,0.0};
		char
			ca6[2][31]={"A0561"," "};
		int
			ip7[2]={300,100};
		int
			ret_code;
		
		rout_number++;
		sprintf(User_defind_path_name,"A0561_%03d",rout_number);
		strcpy(ca6[0],User_defind_path_name);
		ret_code=uc1613(cp1,cp2,ip3,ia4,ra5,ca6,ip7);
		if(ret_code==2)
			goto label_finish;
		if(ret_code==1)
			goto label_uc1613;

		
		NumberOfPointsInPath=ia4[1];
		
		strcpy(User_defind_path_name,ca6[0]);

		if(NumberOfPointsInPath>100)
		{
			uc1601("     100,  , ",1);
			ia4[1]=99;
			goto label_uc1613;
		}
		
		if(NumberOfPointsInPath<0)
		{
			uc1601("     100,   ,  , ",1);
			ia4[1]=99;
			goto label_uc1613;
		}

		
	}

label_select:
//   
	{

		// UF_UI_select_with_class_dialog
		char*
			message="  ";
		char*
			title=" ";
		int
			scope=UF_UI_SEL_SCOPE_WORK_PART;
		
		void*
			user_data=NULL;
		int
			response;
		int
			ret_code;
		int
			i;



		ret_code=UF_UI_select_with_class_dialog
			(message,title,scope,rivet_init_proc,NULL,&response,&count,&object);

		if(ret_code==1105012)
		{
			uc1601("     ",1);
			goto label_finish;
		}

		if(ret_code)
		{
			uc1601(" UF_UI_select_with_class_dialog",1);
			goto label_finish;
		}
		if(response==UF_UI_BACK)
			goto label_select;
		if(response==UF_UI_CANCEL)
			goto label_finish;

		if(object)
			for(i=0;i<count;i++)
				UF_CALL(UF_DISP_set_highlight(object[i],0));
		
		//NumberOfPointsInPath=count;
		fprintf(fpdf,"$$PATH, %s, %2d\n",User_defind_path_name,NumberOfPointsInPath);

		{
			char	mess[300];

			if(count<NumberOfPointsInPath)
			{
				sprintf(mess,
					"  = %d	<>    = %d",
					NumberOfPointsInPath,count);
				uc1601(mess,1);
				goto label_select;
			}

			if(count>NumberOfPointsInPath)
			{
				sprintf(mess,
					"  = %d	<>    = %d",
					NumberOfPointsInPath,count);
				uc1601(mess,1);
				goto label_select;
			}

		}


	}


//  
	{

		char
			part_name[256+1];
		char
			refset_name[30+1];
		char
			instance_name[30+1];
		double
			origin[3];
		double
			csys_matrix[9];
		double
			transform[4][4];
		double
			abs_zero[3]={0.0,0.0,0.0},
			wcs_zero[3];
		char*
			fastener_code="3404680D50";		//"3404680D50";	"3404680D40"
		int
			grip_length=80;	
		double
			origin_wcs[3],
			normal_wcs[3];
		int
			i;
		char*
			str_grip_length	= "125";		//"125"  "095";  

		//UF_CALL(UF_CSYS_map_point
		//		(UF_CSYS_ROOT_COORDS,abs_zero,UF_CSYS_ROOT_WCS_COORDS,wcs_zero));

		for(i=0;i<count;i++)
		{
			//      
			UF_CALL(UF_ASSEM_ask_component_data
			(object[i],part_name,refset_name,instance_name,origin,csys_matrix,transform));
			//   
			if(strstr(part_name, "5_12.5"))	//		"5_12.5"  "4_9.5"
			{grip_length=95;		//grip_length=95;  grip_length=125;
			}
			/*
			else 
				if(strstr(part_name,"4-8"))
					grip_length=110;
				else
					grip_length=0;
			*/
			/*
			//       
			UF_CALL(UF_CSYS_map_point
				(UF_CSYS_ROOT_COORDS,origin,UF_CSYS_ROOT_WCS_COORDS,origin_wcs));

			//       
			UF_CALL(UF_CSYS_map_point
				(UF_CSYS_ROOT_COORDS,csys_matrix+6,UF_CSYS_ROOT_WCS_COORDS,normal_wcs));
			
			//UF_VEC3_sub(normal_wcs,wcs_zero,normal_wcs);
			UF_VEC3_sub(normal_wcs, origin_wcs, normal_wcs);
			*/



			//  Position  Action
			/*
			fprintf(fpdf,
				"HA, %s, %03d, %s_%02d, 0, %12.5f, %12.5f, %12.5f, %12.5f, %12.5f, %12.5f, 1, 0, 0\n",
				fastener_code,
				grip_length,
				User_defind_path_name,
				i+1,
				origin_wcs[0],origin_wcs[1],origin_wcs[2],
				normal_wcs[0],normal_wcs[1],normal_wcs[2]);
			*/


			fprintf(fpdf,
				"HA, %s, %s, %s_%02d, 0, %12.5f, %12.5f, %12.5f, %12.5f, %12.5f, %12.5f, 1, 0, 0\n",
				fastener_code,
				str_grip_length,
				User_defind_path_name,
				i+1,
				origin[0],origin[1],origin[2],
				csys_matrix[6], csys_matrix[7], csys_matrix[8]);


		}

	}


//   
	if(object)
		UF_free(object);

label_uc1603:
//  ????
	{
		char*	
			cp1="   ";
		int
			ip2=0;
		char
			cp3[][38]={"  "};
		int
			ip4=1;
		int
			ret_code;


		ret_code=uc1603(cp1,ip2,cp3,ip4);
		switch(ret_code){
			case 1:		goto label_uc1603;
			case 2:		goto label_finish;
			case 19:	goto label_finish;
			default:	goto label_uc1613;
		}

	}



//    
label_finish:
	fflush(fpdf);
	fclose(fpdf);

	return;
}






/*****************************************************************************
**  Activation Methods
*****************************************************************************/
/*  Unigraphics Startup
**      This entry point activates the application at Unigraphics startup */
extern DllExport void ufsta( char *param, int *returnCode, int rlen )
{
    /* Initialize the API environment */
    if( UF_CALL(UF_initialize()) ) 
    {
        /* Failed to initialize */
        return;
    }
    
    /* TODO: Add your application code here */
	do_it();
    /* Terminate the API environment */
    UF_CALL(UF_terminate());
}



/*****************************************************************************
**  Utilities
*****************************************************************************/

/* Unload Handler
**     This function specifies when to unload your application from Unigraphics.
**     If your application registers a callback (from a MenuScript item or a
**     User Defined Object for example), this function MUST return
**     "UF_UNLOAD_UG_TERMINATE". */
extern int ufusr_ask_unload( void )
{
    return( UF_UNLOAD_UG_TERMINATE );
}

void ufusr_cleanup(void)
 {
    /* Perform cleanup */
 }